using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace UACDemo
{
    internal class InteropDefs
    {
        #region SetButtonShield
        public static void SetButtonShield(
            System.Windows.Forms.Button Button, 
            bool ShowShield)
        {
            SendMessage(new HandleRef(Button, Button.Handle), 
                BCM_SETSHIELD, IntPtr.Zero, ShowShield);
        }

        // SendMessage override for BCM_SETSHIELD message
        [DllImport("user32.dll")]
        static extern IntPtr SendMessage(HandleRef hWnd, 
            uint Msg, IntPtr wParam, bool lParam);

        const int BCM_FIRST = 0x1600;
        const int BCM_SETSHIELD = (BCM_FIRST + 0x000C);

        #endregion

        
        #region Elevate COM Object

        [return: MarshalAs(UnmanagedType.Interface)]
        static internal object LaunchElevatedCOMObject(Guid Clsid, Guid InterfaceID)
        {
            string CLSID       = Clsid.ToString("B"); // B formatting directive: returns {xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx} 
            string monikerName = "Elevation:Administrator!new:" + CLSID;

            BIND_OPTS3 bo = new BIND_OPTS3();
            bo.cbStruct   = (uint)Marshal.SizeOf(bo);
            bo.hwnd       = IntPtr.Zero;
            bo.dwClassContext = (int)CLSCTX.CLSCTX_ALL; 
            
            object retVal = CoGetObject(monikerName, ref bo, InterfaceID);

            return (retVal);
        }

        [Flags]
        enum CLSCTX : uint
        {
            CLSCTX_INPROC_SERVER = 0x1,
            CLSCTX_INPROC_HANDLER = 0x2,
            CLSCTX_LOCAL_SERVER = 0x4,
            CLSCTX_REMOTE_SERVER = 0x10,
            CLSCTX_NO_CODE_DOWNLOAD = 0x400,
            CLSCTX_NO_CUSTOM_MARSHAL = 0x1000,
            CLSCTX_ENABLE_CODE_DOWNLOAD = 0x2000,
            CLSCTX_NO_FAILURE_LOG = 0x4000,
            CLSCTX_DISABLE_AAA = 0x8000,
            CLSCTX_ENABLE_AAA = 0x10000,
            CLSCTX_FROM_DEFAULT_CONTEXT = 0x20000,
            CLSCTX_INPROC = CLSCTX_INPROC_SERVER | CLSCTX_INPROC_HANDLER,
            CLSCTX_SERVER = CLSCTX_INPROC_SERVER | CLSCTX_LOCAL_SERVER | CLSCTX_REMOTE_SERVER,
            CLSCTX_ALL = CLSCTX_SERVER | CLSCTX_INPROC_HANDLER
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct BIND_OPTS3
        {
            public uint cbStruct;
            public uint grfFlags;
            public uint grfMode;
            public uint dwTickCountDeadline;
            public uint dwTrackFlags;
            public uint dwClassContext;
            public uint locale;
            object pServerInfo; // will be passing null, so type doesn't matter
            public IntPtr hwnd;
        }

        [DllImport("ole32.dll", CharSet = CharSet.Unicode, ExactSpelling = true, PreserveSig = false)]
        [return: MarshalAs(UnmanagedType.Interface)]
        static extern object CoGetObject(
           string pszName,
           [In] ref BIND_OPTS3 pBindOptions,
           [In, MarshalAs(UnmanagedType.LPStruct)] Guid riid);

        #endregion
    }
}
